"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const uuid_1 = require("uuid");
const hls_js_1 = __importDefault(require("hls.js"));
const DEFAULT_CLASSNAME = "sldp-react-player";
const FallbackPlayer = ({ streamUrl, wrapperId = `sldp-react-player-${(0, uuid_1.v4)()}`, muted, width, height }) => {
    const [videoEl, setVideoEl] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (!videoEl)
            return;
        if (hls_js_1.default.isSupported()) {
            var hls = new hls_js_1.default();
            hls.loadSource(streamUrl);
            hls.attachMedia(videoEl);
        }
        // HLS.js is not supported on platforms that do not have Media Source
        // Extensions (MSE) enabled.
        //
        // When the browser has built-in HLS support (check using `canPlayType`),
        // we can provide an HLS manifest (i.e. .m3u8 URL) directly to the video
        // element through the `src` property. This is using the built-in support
        // of the plain video element, without using HLS.js.
        //
        // Note: it would be more normal to wait on the 'canplay' event below however
        // on Safari (where you are most likely to find built-in HLS support) the
        // video.src URL must be on the user-driven white-list before a 'canplay'
        // event will be emitted; the last video event that can be reliably
        // listened-for when the URL is not on the white-list is 'loadedmetadata'.
        else if (videoEl.canPlayType('application/vnd.apple.mpegurl')) {
            videoEl.src = streamUrl;
        }
    }, [videoEl, streamUrl]);
    return react_1.default.createElement("div", { id: wrapperId, className: DEFAULT_CLASSNAME, style: { width, height } },
        react_1.default.createElement("video", { ref: (el) => { setVideoEl(el); }, width: "100%", height: "100%", controls: false, autoPlay: true, muted: muted, playsInline: true }));
};
exports.default = FallbackPlayer;
